#include<iostream>

using namespace std;
class Zasobnik
{
private:
	int velikost ;  
	int* data;  //pole dat
	int vrchol = 0;//index vrcholu zasobniku, prvni volne pozice
public:

	Zasobnik(int velikost=100)
	{
		data = new int[velikost];
		this->velikost = velikost;
	}

	~Zasobnik()
	{
		delete[] data;
	}

	int push(int x)
	{
		if (vrchol == velikost) //indexy 0 - (N-1) jsou obsazeny, vrchol je jiz mimo rozsah pole
			return -1;
		else
		{
			//zapis na vrchol zasobniku,pote se provede inkrementace pomoci ++
			data[vrchol++] = x;
			return 0;
		}
	}

	int pop(int &x)
	{
		//prazdny zasobnik - chyba
		if (vrchol == 0)
			return -1;
		else
		{
			//cteni z vrcholu zasobniku (prvni je treba provest dekrementaci - vrchol je prvni volna pozice, ne posledni vlozeny prvek)
			x = data[--vrchol];
			return 0;
		}
	}

	//funkce ktera vrati hodnotu prvku na vrcholu zasobniknu beze jeho odebrani
	int top()
	{
		if (vrchol == 0)
			return -1;
		else
			return data[vrchol - 1];

	}

	void report()
	{
		if (isEmpty())
			cout << "Zasobnik je prazdny." << endl;
		else
		{
			cout << "Obsah zasobniku (od vrcholu):" << endl;
			for (int i = vrchol - 1; i >= 0; i--)
				cout << data[i] << " ";
			cout << endl;
		}
	}

	bool isEmpty()
	{
		return vrchol == 0;
	}
};